import 'package:flutter/cupertino.dart';

enum DialogType { option, confirm, waiter }

//DialogRequest is sent out to the manager while a dialog is being invoked.
//Based on the dialogRequest, the manager class decides which dialog to invoke.
class DialogRequest {
  final Widget title;
  final Widget description;
  final DialogType dialogType;
  final String optionLeft;
  final String optionRight;
  final String buttonText;

  DialogRequest(
      {this.title,
      this.description,
      this.buttonText,
      this.optionRight,
      this.optionLeft,
      this.dialogType});
}

//Dialog Response holds the response based on user action.
// It can received asynchronously in the same context from which the dialog was invoked.
class DialogResponse {
  final String optionLeft;
  final String optionRight;
  final bool confirmed;

  DialogResponse({
    this.optionLeft,
    this.optionRight,
    this.confirmed = false,
  });
}
